#define WAF2_LOGGING_ENABLE

#include "HtsenseUtil.h"
#include "waf2_logging.h"
#include <arpa/inet.h>
#include <netinet/in.h>
#include <string.h>
#include <cstdlib>
#include <iomanip>
#include <sstream>

#define int_ntoa(x) inet_ntoa(*((struct in_addr *)&x))

// Fix old gcc bug
union uint_inaddr_u{
	u_int u;
	struct in_addr a;
};

char *tuple4_to_str(struct tuple4 addr) {
	static char buf[1024];

	uint_inaddr_u un;
	un.u = addr.saddr;
	struct in_addr *psaddr = &un.a;
	strcpy (buf, inet_ntoa(*psaddr));
	sprintf (buf + strlen (buf), ":%i-", addr.source);

	un.u = addr.daddr;
	struct in_addr *pdaddr = &un.a;
	strcat (buf, inet_ntoa(*pdaddr));
	sprintf (buf + strlen (buf), ":%i", addr.dest);
	return buf;
}

void util_hex_dump(const char *data, size_t size) {
	char ascii[17];
	size_t i, j;
	ascii[16] = '\0';
	std::stringstream line;
	for (i = 0; i < size; ++i) {
		line << std::hex << std::setfill('0') << std::setw(2) << (int)((unsigned char*)data)[i] << " ";
		if (((unsigned char*)data)[i] >= ' ' && ((unsigned char*)data)[i] <= '~') {
			ascii[i % 16] = ((unsigned char*)data)[i];
		} else {
			ascii[i % 16] = '.';
		}
		if ((i+1) % 8 == 0 || i+1 == size) {
			line << " ";
			if ((i+1) % 16 == 0) {
				line << "|  " << ascii;
				waf2_log(WAF2_LOG_TRACE, "%s", line.str().c_str());
				// reset string stream to be empty
				line.clear(); // only resets stream flags
				line.str(std::string()); // make it empty
			} else if (i+1 == size) {
				ascii[(i+1) % 16] = '\0';
				if ((i+1) % 16 <= 8) {
					line << " ";
				}
				for (j = (i+1) % 16; j < 16; ++j) {
					line << "   ";
				}
				line << "|  " << ascii;
				waf2_log(WAF2_LOG_TRACE, "%s", line.str().c_str());
				// reset string stream to be empty
				line.clear(); // only resets stream flags
				line.str(std::string()); // make it empty
			}
		}
	}
}

bool my_atoi(int &val, const char *s) {
	char *end;
	val = strtol(s, &end, 10);
	return (end == s + strlen(s)); // value should contain only the number without any extra characters
}

