#ifndef __WAF2_LOGGING_H__b7712f06
#define __WAF2_LOGGING_H__b7712f06

#ifndef _GNU_SOURCE
#define _GNU_SOURCE /* Required for correct functionality of basename() function when built with GCC */
#endif
#include <string.h>
#include <libgen.h>
#include <sys/time.h>
#include <time.h>
#include <stdio.h>
#include <stdarg.h>

//#define WAF2_LOGGING_ENABLE

enum Waf2LogLevels {
	WAF2_LOG_TRACE,
	WAF2_LOG_DEBUG,
	WAF2_LOG_INFO,
	WAF2_LOG_WARNING,
	WAF2_LOG_ERROR,
	WAF2_LOG_LEVELS_COUNT
};

#ifdef WAF2_LOGGING_ENABLE

#define waf2_log(_loglevel, _fmt, args...) while ((_loglevel) >= g_loglevel) { \
	const char *logLevelNames[WAF2_LOG_LEVELS_COUNT] = {         \
		"TRACE", "DEBUG", "INFO", "WARNING", "ERROR" };      \
	const char *loglevelstr =                                    \
		((unsigned int)_loglevel >= WAF2_LOG_LEVELS_COUNT) ?     \
			"unknown" : logLevelNames[_loglevel];                \
	struct timeval tv;                                           \
	time_t timenow;                                              \
	struct tm *tmnow;                                            \
	char tmstr[200];                                             \
	gettimeofday(&tv, NULL);                                     \
	timenow = tv.tv_sec;                                         \
	tmnow = localtime(&timenow);                                 \
	strftime(tmstr, sizeof tmstr, "%Y-%m-%d %H:%M:%S", tmnow);   \
	fprintf(stderr, "[%s,%03ld] [%s]: " _fmt "\n",               \
		tmstr, tv.tv_usec / 1000, loglevelstr, ##args);          \
    break;                                                       \
}

#define waf2_log_set_level(_loglevel) do { \
	g_loglevel = _loglevel;            \
} while(0)

#define waf2_log_level() g_loglevel

#else
#define waf2_log(_loglevel, _fmt, args...)
#define waf2_log_set_level(_loglevel)
#define waf2_log_level() g_loglevel
#endif

extern int g_loglevel;

#endif // __WAF2_LOGGING_H__b7712f06
